var gulp = require('gulp');
var browserify = require('browserify');
var proxyquire = require('proxyquireify');
var gutil = require('gulp-util');
var streamify = require('gulp-streamify')
var clean = require('gulp-clean');
var glob = require('glob').sync;
var rename = require('gulp-rename');
var uglify = require('gulp-uglify');
var source = require('vinyl-source-stream');

var pkg = require('./package.json');
var target = './build/';

gulp.task('default', ['browserify-tests'], function () {
    gulp.watch(['./src/*.js', 'test/*.test.js'], ['browserify-tests']);
});

gulp.task('browserify-tests', function () {
    var t = browserify()
        // .plugin(proxyquire.plugin)
        .require(glob('./test/*.test.js'), {entry: true});

    t.bundle({debug: true})
        .on('error', gutil.log)
        .pipe(source('tests.js'))
        .pipe(gulp.dest(target));
});

gulp.task('clean', function () {
    gulp.src(target, {read: false}).pipe(clean());
});

gulp.task('build', ['clean'], function () {
    var b = browserify('./' + pkg.main);
    b.bundle({standalone: pkg.name})
        .on('error', gutil.log)
        .pipe(source(pkg.name + '.js'))
        .pipe(gulp.dest(target))
        .pipe(streamify(uglify()))
        .pipe(rename({extname: '.min.js'}))
        .pipe(gulp.dest(target))
});