var extend = require('extend');
var URI = require('URIjs');

module.exports = function (options, jsonp, prompt) {
    var noembedUrl = 'http://noembed.com/embed';
    options = extend({
        nowrap: 'on'
    }, options);

    return function (scribe) {
        var emebed = new scribe.api.Command('insertHTML');
        emebed.nodeName = 'IFRAME';

        emebed.execute = function () {
            var self = this;

            link = prompt ? prompt() : window.prompt('Enter video url');
            if (link) {
                if (typeof link === 'object') {
                    // If some extra properties were passed from prompt
                    options = extend(options, link);
                } else if (typeof link === 'string') {
                    options.url = link
                };

                // Attributes will be applied to returned iframe
                var attrs = pluck(options, 'attributes');
                // Parametres applied to iframe url
                var params = pluck(options, 'parameters');

                jsonp(noembedUrl, options, function (video) {
                    var host = document.createElement('div');
                    host.innerHTML = unescape(video.html);
                    var frame = host.querySelector('iframe');

                    addAttributes(frame, attrs);
                    addParameters(frame, params);

                    scribe.api.SimpleCommand.prototype.execute.call(self, frame.outerHTML);
                });
            }

        }

        scribe.commands.oembedPrompt = emebed;
    };
}

function addParameters (el, params) {
    var src = el.getAttribute('src');
    if (!src) throw new TypeError('Returned iframe missing src parameter');
    url = new URI(src);
    url.query(params);

    el.setAttribute('src', url);
}

function addAttributes (el, attrs) {
    for (var prop in attrs) {
        el.setAttribute(prop, attrs[prop]);
    }
}

function pluck (obj, prop) {
    var val = obj[prop];
    delete obj[prop]
    return val;
}