var oembedPrompt = require('../src/main.js');
var f = function() {return {}};
var scribeShim = {
    api: { Command: f, SimpleCommand: {prototype: {execute: f}} },
    commands: {}
};

describe('main', function(){
    it('should return a function', function () {
        expect(typeof oembedPrompt).toBe('function');
    });
});

describe('plugin', function () {
    var plugin, p;

    beforeEach(function () {
        p = {
            jsonp: function (url, options, cb) {cb({html: '<iframe src="http://youtube.com">test</iframe>'});},
            prompt: function () { return 'url'; }
        };

        spyOn(p, 'jsonp').andCallThrough();
        spyOn(p, 'prompt').andCallThrough();
        spyOn(scribeShim.api.SimpleCommand.prototype, 'execute');

        plugin = oembedPrompt({attributes: {'class': 'test'}, parameters: {t:2}}, p.jsonp, p.prompt);
    });

    it('should call prompt and jsonp when executed', function () {
        plugin(scribeShim);
        scribeShim.commands.oembedPrompt.execute();

        expect(p.prompt).toHaveBeenCalled();
        expect(p.jsonp).toHaveBeenCalledWith(
            'http://noembed.com/embed',
            {nowrap: 'on', url: 'url'},
            jasmine.any(Function)
        );
    });

    it('should return proper iframe with class', function () {
        plugin(scribeShim);
        scribeShim.commands.oembedPrompt.execute();

        expect(scribeShim.api.SimpleCommand.prototype.execute)
            .toHaveBeenCalledWith('<iframe src="http://youtube.com/?t=2" class="test">test</iframe>');
    });
})